#include <iostream>
#include <string>
#include <list>
#include <signal.h>
#include <stdlib.h>

#include "Messagetypes.h"
using namespace std;

#define ESPERA		500
#define MIN_SHOT	1.0
#define MAX_SHOT	30.0

typedef struct {
	int type;
	double dist, angle;
} object_t;

list<object_t> obj_list;

int status;
#define S_NOR		0
#define S_COL		1
#define S_ATC		2
#define S_GIR		3
#define S_GO		4

using namespace std;

message_to_robot_type get_msgtype(char *msg) {
	int i;

	for(i = 0 ; message_to_robot[i].msg[0] != '\0' ; i++) {
		if (!strcmp(message_to_robot[i].msg, msg)) {
			return (message_to_robot_type)i;
		}
	}
	return UNKNOWN_MESSAGE_TO_ROBOT;
}


void check_messages(int sig) {
	int cnt, cnt2;
	char line[1024];
	message_to_robot_type mtype;

	cin.clear();
	
	cnt = 0;
	cnt2 = 0;
	while (!cin.eof()) {
		cin >> line;
		mtype = get_msgtype(line);

		switch(mtype) {
			object_t obj;
			case INITIALIZE:
				int val;
				cin >> val;
				if (val == 1) {
					cout << "Name BURUBU" << endl;
					cout << "Colour ABEEBB EE3050" << endl;
				}
				break;

			case GAME_STARTS:
				status = S_NOR;
				cout << "Accelerate 1" << endl;
				break;

			case RADAR:
				cin >> obj.dist >> obj.type >> obj.angle;
				obj_list.push_front(obj);
				break;
				
			case COLLISION:
				obj.dist = 0;
				cin >> obj.type >> obj.angle;
				break;

			case DEAD:
				cout << "Print BYE BYE.. x)" << endl;
				break;

			case GAME_FINISHES:
				
			case EXIT_ROBOT:
				exit(0);
			case WARNING:
				char text[81];
				cin.getline(text,80,'\n');
				cout << "Print Warning!!  " << text << endl;
				break;
					  
		}

		status = S_NOR;
		
		list<object_t>::iterator i = obj_list.begin();
		while (obj_list.end() != i) {
			switch (i->type) {
				case ROBOT:  
					status = S_ATC;
					break;
				case WALL:
					if (cnt2 <= 0) {
						if (i->dist < 6.5) status = S_GIR;
						if (i->dist < 1) status = S_COL;
					}
					break;
				case MINE: 
					if (i->dist < 4) {
						cout << "Shoot 1" << endl;
						status = S_GIR;
					} else status = S_ATC;
					break;
				case COOKIE: 
					status = S_GO;
			}

			if (status != S_NOR) break;
			i++;
		}

		switch(status) {
			double forza, varangle;
			int pos;
			case S_GO:
				cout << "Print GO!" << endl;
				//cout << "Brake 0" << endl;
				cout << "RotateAmount 1 30 " << i->angle << endl;
				break;
			case S_ATC:
				cout << "Print ATC!" << endl;
				cout << "RotateAmount 1 50 " << i->angle << endl;
				if (i->type == ROBOT) {
					forza = MIN_SHOT+(MAX_SHOT/(i->dist*i->dist));
				}
				if (i->type == MINE) forza = MIN_SHOT;
				cout << "Print Forza " << forza << endl;
				cout << "Shoot " << forza << endl;
				break;
			case S_COL:
				varangle = 2.1;
				cnt2 = ESPERA;
				cout << "Print COL!" << endl;
				obj_list.clear();
				cout << "Brake 0" << endl;
				cout << "Accelerate 0.2" << endl;
				cout << "RotateAmount 1 40 " << varangle << endl;
				break;
			case S_GIR:
				varangle = 1.7;
				pos = 0;
				if (i->type == WALL) cnt2 = ESPERA;
				cout << "Print GIR!" << endl;
				obj_list.clear();
				cout << "Accelerate 0.5" << endl;
				cout << "RotateAmount 1 30 "<< varangle << endl;

		}

		if (++cnt == 5) {
			obj_list.clear();
			cnt = 0;
		}
		if (cnt2 == 5) {
			cout << "Accelerate 1" << endl;
			cout << "Print Accelerant!" << endl;
		}
		cnt2--;

	}
}
      
int main() {
	sigset_t usr1set;
/*
	signal(SIGUSR1, check_messages);

	sigemptyset(&usr1set);
	sigaddset(&usr1set, SIGUSR1);
	sigprocmask(SIG_UNBLOCK, &usr1set, NULL);

	cout << "RobotOption " << (int)SIGNAL << " " << (int)SIGUSR1 << endl;
*/
	cout << "RobotOption " << 3 << " " << 0 << endl;
	cout << "RobotOption " << 1 << " " << 2 << endl;

	check_messages(0);
	/*
	while(1) {
		sleep(10);
	}
	*/
}
